# groove.rb: Written by Tadayoshi Funaba 2005,2006,2008,2014
# $Id: groove.rb,v 1.4 2014-03-22 07:48:58+09 tadf Exp $

require 'gsl'

module SMF

  class Groove

    def initialize(div, pat)
      @unit = pat[-1] * div * 4
      x = []; y = []
      pat.each_with_index do |p, i|
	x << @unit / (pat.size - 1) * i
	y << p * div * 4
      end
      x2 = GSL::Vector.alloc(x)
      y2 = GSL::Vector.alloc(y)
      @spline = GSL::Spline.alloc('linear', x2, y2)
      self.amount = 0.5
    end

    def amount=(v) @amount = v end

    def groove(ev)
      q, r = ev.offset.divmod(@unit)
      r2 = @spline.eval(r)
      r3 = r + (r2 - r) * @amount
      ev.offset = (q * @unit + r3).round
    end

  end

end
