# coding: utf-8
# stt.rb: Written by Tadayoshi Funaba 2005,2014
# $Id: stt.rb,v 1.3 2014-04-27 08:46:58+09 tadf Exp $

unless defined?(Encoding)
  $KCODE = 'u'
  require 'jcode'
else
#  Encoding.default_external = 'utf-8'
end

require 'smf/toy/macro/mml'
require 'kconv'

module SMF

  class STT < MML

    NOTETAB = { 'ラ'=>'a', 'シ'  =>'b', 'ド'=>'c', 'レ'=>'d',
		'ミ'=>'e', 'ファ'=>'f', 'ソ'=>'g', 'ッ'=>'r' }

    def << (s)
      s2 = s.toutf8.
	gsub(/(ラ|シ|ド|レ|ミ|ファ|ソ|ッ)([$%#♭％＃]+)?([,'，’]+)?(ー+)?/) do
	n, s, o, x = $1, $2, $3, $4
	no = NOTETAB[n]
	no += s.tr('♭％＃', '$%#') if s
	no += o.tr('，’', ",'") if o
	le = 1
	if ''.respond_to?(:jsize)
	  le += x.jsize if x
	else
	  le += x.size if x
	end
	format('{le*=%d %s}', le, no)
      end
      super(s2)
    end

  end

end
