# shuffle.rb: Written by Tadayoshi Funaba 2005,2006,2008,2014
# $Id: shuffle.rb,v 1.5 2014-03-22 07:48:58+09 tadf Exp $

require 'gsl'

module SMF

  class Shuffle

    def initialize(div, beat=1.0/8)
      @unit = beat * div * 4
      self.amount = 0.5
    end

    def amount=(v)
      qunit = @unit / 4
      shift = @unit / 2 * v
      x = GSL::Vector.alloc(0, qunit, qunit*2, qunit*3, @unit)
      y = GSL::Vector.alloc(0, qunit + shift*0.25, qunit*2 + shift, qunit*3 + shift*0.5, @unit)
      @spline = GSL::Spline.alloc('linear', x, y)
    end

    def shuffle(ev)
      q, r = ev.offset.divmod(@unit)
      r2 = @spline.eval(r)
      ev.offset = (q * @unit + r2).round
    end

  end

end
