# velcomp.rb: Written by Tadayoshi Funaba 2005,2006,2008,2014
# $Id: velcomp.rb,v 1.4 2014-03-22 07:48:58+09 tadf Exp $

require 'gsl'

module SMF

  class VelComp

    def initialize
      self.gain = 0
      self.thresh = 80
      self.ratio = 0.9
    end

    def init
      max = @thresh + (127 - @thresh) * @ratio
      x = GSL::Vector.alloc(0, @thresh, 127)
      y = GSL::Vector.alloc(0, @thresh, max)
      @spline = GSL::Spline.alloc('linear', x, y)
    end

    private :init

    def gain=(v) @gain = v end
    def thresh=(v) @thresh = v; @spline = nil end
    def ratio=(v) @ratio = v; @spline = nil end

    def velcomp(ev)
      init unless @spline
      v = ev.vel + @gain
      v = 127 if v > 127
      v = 1   if v < 1
      v2 = @spline.eval(v)
      v2 = 127 if v > 127
      v2 = 1   if v < 1
      ev.vel = v2.round
    end

  end

end
